using System.Collections;
using System.Collections.Generic;
using UnityEngine;

//////////////////////////////////////////////////////////////////
//yubÑRg[ɎgpNXz
// ubN̈ړƈړ̈ړ͈͊mF̎{
//////////////////////////////////////////////////////////////////
public class BlockController : MonoBehaviour
{
    /////////////////////////////////
    // yϐ̐ݒz
    /////////////////////////////////

    //ỹvOŎgpPrivateϐz
    private TileManager cl_TileManager;  // TileManager̊֐Ăяop
    private BlockGenerator cl_BlockGenerator;  // BlockGenerator̊֐Ăяop
    private float time_Fall = 0;  // ubN̉ւ̈ړ^C~OǗ


    /////////////////////////////////
    // y֐̐ݒz
    /////////////////////////////////

    //yQ[JnɂP񂾂֐z
    //iUnity̕W֐j
    void Start()
    {
        // SceneGameManagerQ[IuWFNgTileManagerR|[lg擾
        //iubN͂ƂSceneɂȂ̂Ŏ쐬ꂽۂSceneォ擾j
        cl_TileManager = GameObject.Find("GameManager").GetComponent<TileManager>();
        // SceneGameManagerQ[IuWFNgBlockGeneratorR|[lg擾
        cl_BlockGenerator = GameObject.Find("GameManager").GetComponent<BlockGenerator>();
    }


    //yt[ɂPx֐z
    //iUnity̕W֐j
    void Update()
    {
        // ScoreManagerGame_Pauseꎞ~̏ꍇAUpdate֐̏ȏsȂ
        if (ScoreManager.Game_Pause) return;

        // ubN̉ړ^C~O̕ϐtime_Fall1t[̌oߎԂZ
        time_Fall += Time.deltaTime;

        // L[ꂽꍇ
        if (Input.GetKeyDown(KeyCode.LeftArrow))
        {
            // ubNɂPړ
            transform.position += new Vector3(-1, 0, 0);
            // ړ͈͂ubNoĂi[oA͍ɑ̃ubNj
            if (!CheckMoveArea())
            {
                // ubNEɂP߂
                transform.position -= new Vector3(-1, 0, 0);
            }
        }

        // EL[ꂽꍇ
        else if (Input.GetKeyDown(KeyCode.RightArrow))
        {
            // ubNEɂPړ
            transform.position += new Vector3(1, 0, 0);
            // ړ͈͂ubNoĂiE[oA͉Eɑ̃ubNj
            if (!CheckMoveArea())
            {
                // ubNɂP߂
                transform.position -= new Vector3(1, 0, 0);
            }   
        }

        // L[ꂽꍇƁA
        // ϐtime_FallScoreManagerŊǗubN̉ړ̎ԊԊu𒴂Ăꍇ
        else if (Input.GetKeyDown(KeyCode.DownArrow) || time_Fall >= ScoreManager.Time_Fall)
        {
            // ubNɂPړ
            transform.position += new Vector3(0, -1, 0);
            // ړ͈͂ubNoĂi[oA͉ɑ̃ubNj
            if (!CheckMoveArea())
            {
                // ubNɂP߂
                transform.position -= new Vector3(0, -1, 0);

                // ubN[܂œ̂Œǉs
                // ̃ubN̊e^CTransformɑ΂ďԂɏ
                foreach (Transform childTrans in transform)
                {
                    // e^C̏TileManagerɒǉ֐Ăяo
                    cl_TileManager.AddToTile(childTrans);
                }

                // TileManager̊eQ[[hɑ΂Tile`FbN֐Ăяo
                cl_TileManager.CheckTiles();
                // ubNBlockGenerator̎֐Ăяo
                cl_BlockGenerator.Generate_Block();

                // ̃ubN̈ړȂ悤ɁAScript𖳌
                this.enabled = false;
            }

            // ubNɂPړ̂ŁAړ^C~OǗtime_FallOZbg
            time_Fall = 0;
        }

        // L[ꂽꍇ
        else if (Input.GetKeyDown(KeyCode.UpArrow))
        {
            // ubN𔽎v90x]
            transform.Rotate(new Vector3(0, 0, 1), 90);

            // ̃ubN̊e^CTransformɑ΂ďԂɏ
            foreach (Transform childTrans in transform)
            {
                // ]̃ubN̊e^C̈ʒuɑ̃^Cꍇ
                if (cl_TileManager.GetTileInfo(childTrans) > 0)
                {
                    // ubNv90x߂
                    transform.Rotate(new Vector3(0, 0, 1), -90);
                    return;
                }
            }

            // ̃ubN̊e^CTransformɑ΂ďԂɏ
            foreach (Transform childTrans in transform)
            {
                // ړ͈͂ubNoĂi[oj
                if (!cl_TileManager.CheckAreaLeft(childTrans))
                {
                    // ubNEɂP߂
                    transform.position += new Vector3(1, 0, 0);
                }

                // ړ͈͂ubNoĂiE[oj
                if (!cl_TileManager.CheckAreaRight(childTrans))
                {
                    // ubNɂP߂
                    transform.position += new Vector3(-1, 0, 0);
                }

                // ړ͈͂ubNoĂi[oj
                if (!cl_TileManager.CheckAreaBottom(childTrans))
                {
                    // ubNɂP߂
                    transform.position += new Vector3(0, 1, 0);
                }
            }
        }
    }


    //yړ͈͂ubNoĂȂƁAړɑ̃ubNȂmF֐z
    private bool CheckMoveArea()
    {
        // ̃ubN̊e^CTransformɑ΂ďԂɏ
        foreach (Transform childTrans in transform)
        {
            // ubNړ͈͂̍[AE[A[oĂꍇ
            if (!cl_TileManager.CheckAreaLeft(childTrans) || !cl_TileManager.CheckAreaRight(childTrans)
                || !cl_TileManager.CheckAreaBottom(childTrans))
            {
                return false;  // falseԂ
            }

            // ubN̈ړ̈ʒuɑ̃ubNꍇ
            if (cl_TileManager.GetTileInfo(childTrans) != 0)
            {
                return false;  // falseԂ
            }
        }
        return true;  // L̈ړ͈̓`FbNŖ肪ȂꍇAtrueԂ
    }
}
