using System.Collections;
using System.Collections.Generic;
using UnityEngine;

using UnityEngine.SceneManagement;  // V[̐؂ւɎgp
using UnityEngine.UI;  // UIgp̂Ɏgp

//////////////////////////////////////////////////////////////////
//yQ[Ŝ̐ƃXRAǗp̃NXz
// Q[[hAꎞ~A̐AXRẢZAQ[I[o[ENA
//////////////////////////////////////////////////////////////////
public class ScoreManager : MonoBehaviour
{
    /////////////////////////////////
    // yϐ̐ݒz
    /////////////////////////////////

    //y萔̐ݒzix݌vŕύX\j
    const int CLEAR_POINT = 1000;  // Q[NÃ|Cg
    const float CLEAR_TIME = 200;  // Q[NA̎
    const int LINE_SCORE = 50;  // PC폜̊l|Cg
    const int TILE_SCORE = 10;  // P^C폜̊l|Cg

    //yUnity EditorIuWFNgւ̃ANZXpϐz
    [SerializeField] private GameObject image_Finish;  // Q[Iɕ\UI
    [SerializeField] private Text text_Finish;  // Q[Ǐʕ\UIeLXg
    [SerializeField] private Text text_Score;  // l|Cgv\UIeLXg

    //yNX̃ANZXpGetter, Setterϐz
    private static int game_Mode = 1;  // Q[[h (1FegA2FՂA3FegՂ)
    public static int Game_Mode
    {
        get  // NXGet
        {
            return game_Mode;
        }

        set  // NXSet
        {
            game_Mode = value;
        }
    }

    private static bool game_Pause = false;  // Q[ꎞ~
    public static bool Game_Pause
    {
        get  // NXGet
        {
            return game_Pause;
        }
    }

    private static float time_Fall;  // ubNɈړ鎞ԊԊuij
    public static float Time_Fall
    {
        get  // NXGet
        {
            return time_Fall;
        }
    }

    //ỹvOŎgpPrivateϐz
    private int score = 0;  // Q[̊l|Cg
    private float game_Time = 0;  // Q[̌oߎ


    /////////////////////////////////
    // y֐̐ݒz
    /////////////////////////////////

    //yQ[JnɂP񂾂֐z
    //iUnity̕W֐j
    void Start()
    {
        // Q[Jn͏Ɉꎞ~͉
        game_Pause = false;
        // ݂̊l|CgUI\
        text_Score.text = score.ToString();
    }


    //yt[ɂPx֐z
    //iUnity̕W֐j
    void Update()
    {
        // Q[̃g[^oߎԂɂPt[̌oߎԂ𑫂
        game_Time += Time.deltaTime;

        // Q[oߎԂɂāAubN鑬ς
        if (game_Time < 30) time_Fall = 1.0f;
        else if (game_Time < 60) time_Fall = 0.6f;
        else time_Fall = 0.2f;

        // Q[oߎԂŒlCLEAR_TIME𒴂Q[NAĂ
        if (game_Time >= CLEAR_TIME) GameClear();
    }


    //yPC폜ɌĂ΂|Cgl֐z
    public void AddLINEScore()
    {
        // scoreɌŒlLINE_SCORE|CgZ
        score += LINE_SCORE;
        // ݂̊l|CgUI\
        text_Score.text = score.ToString();

        // |CgZAQ[NA|CgɒBQ[NA
        if (score >= CLEAR_POINT) GameClear();
    }


    //yP^C폜ɌĂ΂|Cgl֐z
    public void AddTILEScore()
    {
        // scoreɌŒlTILE_SCORE|CgZ
        score += TILE_SCORE;
        // ݂̊l|CgUI\
        text_Score.text = score.ToString();

        // |CgZAQ[NA|CgɒBQ[NA
        if (score >= CLEAR_POINT) GameClear();
    }


    // yQ[I[o[ɌĂ΂Q[I[o[֐z
    public void GameOver()
    {
        // Q[ꎞ~
        game_Pause = true;
        // Q[I[o[UI\
        image_Finish.SetActive(true);
        text_Finish.text = "Game Over";
    }


    // yQ[NAɌĂ΂Q[NA֐z
    public void GameClear()
    {
        // Q[ꎞ~
        game_Pause = true;
        // Q[NAUI\
        image_Finish.SetActive(true);
        text_Finish.text = "Game Clear";
    }


    //y{^p֐z
    //yX^[g{^ŌĂ΂֐z
    public void GameReStart()
    {
        // GameMainV[ēǍ
        SceneManager.LoadScene("GameMain");
    }


    //y{^p֐z
    //yꎞ~{^ŌĂ΂֐z
    public void SetGamePause()
    {
        // ꎞ~̏ꍇ͈ꎞ~
        if (game_Pause) game_Pause = false;
        // Q[s̏ꍇ͈ꎞ~
        else game_Pause = true;
    }


    //y{^p֐z
    //yX^[gʂɖ߂{^ŌĂ΂֐z
    public void BackStart()
    {
        // GameStartV[ēǍ
        SceneManager.LoadScene("GameStart");
    }
}
