using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

//////////////////////////////////////////////////////////////////
//yQ[tB[h̑S^C̈ʒuƎނǗNXz
// Q[tB[h̑S^C̈ʒuƎނǗ
// CĂ邩mFāAC̍폜
// Fł݂ɗאڂĂ^CmFāA^C̍폜
// CE^C̍폜ɏ̃^Cɂ炷
//////////////////////////////////////////////////////////////////
public class TileManager : MonoBehaviour
{
    /////////////////////////////////
    // yϐ̐ݒz
    /////////////////////////////////

    //y萔̐ݒzix݌vŕύX\j
    const int STAGE_WIDTH = 10;  // ubNړłQ[tB[h̉
    const int STAGE_HEIGHT = 20;  // ubNړłQ[tB[h̍
    const int TILE_DEL_NUM_P = 4;  // uՂvŉF̃^C
    const int TILE_DEL_NUM_T = 16;  // uegՂvŉF̃^C

    //yUnity EditorIuWFNgւ̃ANZXpϐz
    [SerializeField] private ScoreManager cl_ScoreManager;  // ScoreManager̊֐Ăяop

    //ỹvOŎgpPrivateϐz
    // Q[tB[h̑S^CTransformێ
    private Transform[,] tiles_Transform = new Transform[STAGE_WIDTH, STAGE_HEIGHT];
    // Q[tB[h̑S^C̎ށiFjێ
    private int[,] tiles_Type = new int[STAGE_WIDTH, STAGE_HEIGHT];
    //uՂvƁuegՂvœF̃^C^C̐
    private int tile_Del_Number;
    //uՂvƁuegՂvŁAS̃^Cɋ󂫂ȂԂɂȂꍇfalse
    private bool tileDownStatus;

    /////////////////////////////////
    // y֐̐ݒz
    /////////////////////////////////

    //yQ[JnɂP񂾂֐z
    //iUnity̕W֐j
    void Start()
    {
        //Q[[huՂv̏ꍇAF̃^Cݒ
        if (ScoreManager.Game_Mode == 2) tile_Del_Number = TILE_DEL_NUM_P;
        //Q[[huegՂv̏ꍇAF̃^Cݒ
        else if (ScoreManager.Game_Mode == 3) tile_Del_Number = TILE_DEL_NUM_T;
    }


    //y^CTransformQ[tB[hXWɕϊ֐z
    private int Get_int_X(Transform trans)
    {
        // ^C̍W̓^C̒SȂ̂ŁA^C̔̑傫0.5𒲐Đ܂
        // Unity͉ʒSWSȂ̂ŁAQ[tB[hSɂ邽߉̔Z
        return
            Mathf.RoundToInt(trans.position.x - 0.5f) + STAGE_WIDTH / 2;
    }


    //y^CTransformQ[tB[hYWɕϊ֐z
    private int Get_int_Y(Transform trans)
    {
        // ^C̍W̓^C̒SȂ̂ŁA^C̔̑傫0.5𒲐Đ܂
        // Unity͉ʒSWSȂ̂ŁAQ[tB[hSɂ邽ߍ̔Z
        return
            Mathf.RoundToInt(trans.position.y - 0.5f) + STAGE_HEIGHT / 2;
    }


    //yQ[tB[hňړI^C̈ʒuƎނǗϐɒǉ֐z
    public void AddToTile(Transform trans)
    {
        // ^CTransform񂩂Q[tB[h̍W擾
        int int_X = Get_int_X(trans);
        int int_Y = Get_int_Y(trans);

        // Q[tB[hňړI^C̎ށiFjǗϐɒǉ
        tiles_Type[int_X, int_Y] = trans.gameObject.GetComponent<TileController>().tile_Type;
        // Q[tB[hňړI^CTransformǗϐɒǉ
        tiles_Transform[int_X, int_Y] = trans;

        // ǉ^C̏܂ōsꍇ
        if (int_Y >= STAGE_HEIGHT - 2)
        {
            // ScoreManager̃Q[I[o[֐Ăяo
            cl_ScoreManager.GameOver();
        }
    }


    //yQ[tB[h̎wꏊɂ^C̎ށiFj擾֐z
    public int GetTileInfo(Transform trans)
    {
        // ^CTransform񂩂Q[tB[h̍W擾
        int int_X = Get_int_X(trans);
        int int_Y = Get_int_Y(trans);

        // ^C̈ړ͈͊OłꍇA^C̎-1Ԃ
        if (int_X < 0 || int_X > STAGE_WIDTH - 1 || int_Y < 0)
        {
            return -1;
        }
        // Q[tB[h̎wꏊɂ^C̎ށiFjԂ
        return tiles_Type[int_X, int_Y];
    }


    //yQ[tB[h̍[oĂ邩mF֐z
    public bool CheckAreaLeft(Transform trans)
    {
        // ^CTransform񂩂Q[tB[h̍W擾
        int int_X = Get_int_X(trans);

        // Q[tB[h̍[oĂꍇAfalseԂ
        if (int_X < 0)
        {
            return false;
        }
        // Q[tB[h̍[oĂȂꍇAtrueԂ
        return true;
    }


    //yQ[tB[h̉E[oĂ邩mF֐z
    public bool CheckAreaRight(Transform trans)
    {
        // ^CTransform񂩂Q[tB[h̍W擾
        int int_X = Get_int_X(trans);

        // Q[tB[h̉E[oĂꍇAfalseԂ
        if (int_X > STAGE_WIDTH -1)
        {
            return false;
        }
        // Q[tB[h̉E[oĂȂꍇAtrueԂ
        return true;
    }


    //yQ[tB[h̉[oĂ邩mF֐z
    public bool CheckAreaBottom(Transform trans)
    {
        // ^CTransform񂩂Q[tB[h̍W擾
        int int_Y = Get_int_Y(trans);

        // Q[tB[h̉[oĂꍇAfalseԂ
        if (int_Y < 0)
        {
            return false;
        }
        // Q[tB[h̉[oĂȂꍇAtrueԂ
        return true;
    }


    //yeQ[[hŕKvȃ^C`FbNs֐z
    public void CheckTiles()
    {
        // eQ[[hŕKvȃ^C`FbN̊֐Ăяo
        switch (ScoreManager.Game_Mode)
        {
            // Q[[huegv̏ꍇ
            case 1:
                CheckAreaLines();
                break;

            // Q[[huՂv̏ꍇ
            case 2:
                // [ɂ܂Ƀ^CȂꍇ̃^Cړ
                tileDownStatus = true;
                while (tileDownStatus)
                {
                    TileDown();
                }

                CheckAreaType();
                break;

            // Q[[huegՂv̏ꍇ
            case 3:
                CheckAreaType();
                CheckAreaLines();
                break;
        }
    }


    //yuegvƁuegՂvp̃CmF֐z
    private void CheckAreaLines()
    {
        // Q[tB[h̏[牺[܂ŏԂɃCmF
        for (int y = STAGE_HEIGHT - 1; y >= 0; y--)
        {
            // CĂ
            if (CheckLine(y))
            {
                // ̃C֐Ă
                DeleteLine(y);
                // ̃C̃^Cɂ炷
                RowDown(y);
            }
        }
    }


    //yws̃CĂ邩mF֐z
    private bool CheckLine(int y)
    {
        // ws̃Q[tB[h[E[܂Ń^C邩mF
        for (int x = 0; x < STAGE_WIDTH; x++)
        {
            // ^CȂfalseԂ
            if (tiles_Type[x, y] == 0)
                return false;
        }

        // ScoreManager̂PC폜̃|Cgl֐Ă
        cl_ScoreManager.AddLINEScore();
        // ws̓CĂ̂trueԂ
        return true;
    }


    //yws̃C֐z
    private void DeleteLine(int y)
    {
        // Q[tB[h̎ws̍[E[܂ŏԂɃ^C
        for (int x = 0; x < STAGE_WIDTH; x++)
        {
            // wW̃^C̃Q[IuWFNg폜
            Destroy(tiles_Transform[x, y].gameObject);
            // wW̃^C̎ނ0i^CȂjɂ
            tiles_Type[x, y] = 0;
            // wW̃^CTransformnulli^CȂjɂ
            tiles_Transform[x, y] = null;
        }
    }


    //yws̃^Cɂ炷֐z
    private void RowDown(int deleteLine)
    {
        // wsQ[tB[h[܂ŏԂɃ^Cɂ炷
        for (int y = deleteLine + 1; y < STAGE_HEIGHT; y++)
        {
            // ws̍[E[܂ŏԂɃ^Cɂ炷
            for (int x = 0; x < STAGE_WIDTH; x++)
            {
                // wWɃ^C
                if (tiles_Type[x, y] != 0)
                {
                    // wW̃^C̎ނPɂ炷
                    tiles_Type[x, y - 1] = tiles_Type[x, y];
                    // wW̃^CTransformPɂ炷
                    tiles_Transform[x, y - 1] = tiles_Transform[x, y];

                    // wW̃^C̎ނ0i^CȂjɂ
                    tiles_Type[x, y] = 0;
                    // wW̃^CTransformnulli^CȂjɂ
                    tiles_Transform[x, y] = null;
                    // wW̃^C̃Q[IuWFNgɂPړ
                    tiles_Transform[x, y - 1].transform.position -= new Vector3(0, 1, 0);
                }
            }
        }
    }


    //yuՂvƁuegՂvp̗אڃ^C̐FmF֐z
    private void CheckAreaType()
    {
        // `FbNɎgpAVector2^̃XgϐsameGroupp
        List<Vector2Int> sameGroup = new List<Vector2Int>();

        // Q[tB[h̉[[܂ŏԂɃ^C̐FmF
        for (int y = 0; y <= STAGE_HEIGHT-1; y++)
        {
            // ws̍[E[܂ŏԂɃ^C̐FmF
            for (int x = 0; x <= STAGE_WIDTH - 1; x++)
            {
                // ̃[vŊmF̒SƂȂwW̃^C̎ނ擾
                int check_Type = tiles_Type[x, y];
                // A̎wWɃ^CȂΎ̃[vĩ^Cjɏi߂
                if (check_Type == 0) continue;

                // Vector2Int^XgϐsameGroup̒gNA
                sameGroup.Clear();
                // ܂̃[vŊmF̒SƂȂwW̃^C̍WXgϐɒǉ
                sameGroup.Add(new Vector2Int(x, y));

                // ꂩFor[vŎgpstartend̕ϐ`
                int start;
                int end = 0;

                // Xgϐ̒g̐endϐ傫ꍇWhile[vJԂ
                while (sameGroup.Count > end)
                {
                    // For[vstartOendɁAendXgϐ̒ǧ݂̐Ƃ
                    start = end;
                    end = sameGroup.Count;

                    //yFאڃ^Cdg݁z
                    // mF̒SƂȂ^C̎l瓯F̃^C邩mFB
                    // F̃^CꍇAXgϐɒǉB
                    //iǉۂɁAɂ̃^CXgϐɓo^ĂȂ`FbNBj
                    // Xgϐɒǉ^CɂāAlɓF̃^C邩ԂɊmFB
                    // F̃^CꍇAXgϐɒǉB
                    // Xgϐɒǉ^CɂāAlɓF̃^C邩ԂɊmFB
                    // F̃^CȂȂ܂ŌJԂB
                    for (int i = start; i < end; i++)
                    {
                        // Ώۂ̃^C̍̃^C`FbN
                        if (sameGroup[i].x >= 1) //Ώۂ[ł͂Ȃꍇ
                        {
                            // Ώۂ̍̃^C̐Fꍇ
                            if (tiles_Type[sameGroup[i].x - 1, sameGroup[i].y] == check_Type)
                            {
                                // ܂Xgϐɂ̍̃^CǉĂȂꍇAXgϐɍWǉ
                                if (!sameGroup.Contains(new Vector2Int(sameGroup[i].x - 1, sameGroup[i].y)))
                                    sameGroup.Add(new Vector2Int(sameGroup[i].x - 1, sameGroup[i].y));
                            }
                        }

                        // Ώۂ̃^C̉Ẽ^C`FbN
                        if (sameGroup[i].x <= STAGE_WIDTH - 2) //ΏۂE[ł͂Ȃꍇ
                        {
                            // Ώۂ̉Ẽ^C̐Fꍇ
                            if (tiles_Type[sameGroup[i].x + 1, sameGroup[i].y] == check_Type)
                            {
                                // ܂Xgϐɂ̉Ẽ^CǉĂȂꍇAXgϐɍWǉ
                                if (!sameGroup.Contains(new Vector2Int(sameGroup[i].x + 1, sameGroup[i].y)))
                                    sameGroup.Add(new Vector2Int(sameGroup[i].x + 1, sameGroup[i].y));
                            }
                        }

                        // Ώۂ̃^C̉̃^C`FbN
                        if (sameGroup[i].y >= 1) //Ώۂ[ł͂Ȃꍇ
                        {
                            // Ώۂ̉̃^C̐Fꍇ
                            if (tiles_Type[sameGroup[i].x, sameGroup[i].y - 1] == check_Type)
                            {
                                // ܂Xgϐɂ̉̃^CǉĂȂꍇAXgϐɍWǉ
                                if (!sameGroup.Contains(new Vector2Int(sameGroup[i].x, sameGroup[i].y - 1)))
                                    sameGroup.Add(new Vector2Int(sameGroup[i].x, sameGroup[i].y - 1));
                            }
                        }

                        // Ώۂ̃^C̏̃^C`FbN
                        if (sameGroup[i].y <= STAGE_HEIGHT - 2) //Ώۂ[ł͂Ȃꍇ
                        {
                            // Ώۂ̏㑤̃^C̐Fꍇ
                            if (tiles_Type[sameGroup[i].x, sameGroup[i].y + 1] == check_Type)
                            {
                                // ܂Xgϐɂ̏㑤̃^CǉĂȂꍇAXgϐɍWǉ
                                if (!sameGroup.Contains(new Vector2Int(sameGroup[i].x, sameGroup[i].y + 1)))
                                    sameGroup.Add(new Vector2Int(sameGroup[i].x, sameGroup[i].y + 1));
                            }
                        }
                    }
                }

                // For[vŊmF^CƓFŗאڂĂ^C̐tile_Del_Number葽ꍇ
                if (sameGroup.Count >= tile_Del_Number)
                {
                    // XgϐsameGroupɓĂ^CiFŗאڂĂ^Cj폜֐Ă
                    DeleteTile(sameGroup);

                    // SẴ^C̉Ƀ^ĈȂȂȂ܂ŁAe^Cɂ炷
                    tileDownStatus = true;
                    while (tileDownStatus)
                    {
                        // Q[tB[h̃^CԂɊmFĉɃ^CȂꍇA^Cɂ炷
                        TileDown();
                    }                    
                }
            }
        }    
    }


    //yXgϐɓĂ^CiFŗאڂĂ^Cj폜֐z
    private void DeleteTile(List<Vector2Int> deleteTiles)
    {
        // XgϐɓĂ^CԂɍ폜Ă
        foreach (Vector2Int vec2int in deleteTiles)
        {
            // Ώۂ̃^C̃Q[IuWFNg폜
            Destroy(tiles_Transform[vec2int.x, vec2int.y].gameObject);
            // Ώۂ̃^C̎ށiFjOi^CȂjɂ
            tiles_Type[vec2int.x, vec2int.y] = 0;
            // Ώۂ̃^CTransformnulli^CȂjɂ
            tiles_Transform[vec2int.x, vec2int.y] = null;

            // ScoreManager̂P^C폜̃|Cgl֐Ă
            cl_ScoreManager.AddTILEScore();
        }
    }


    //yQ[tB[h̃^CԂɊmFĉɃ^CȂꍇA^Cɂ炷֐z
    private void TileDown()
    {
        // Q[tB[h̉[[܂ŏԂɃ^CmF
        for (int y = 1; y < STAGE_HEIGHT; y++)
        {
            // Q[tB[h̍[E[܂ŏԂɃ^CmF
            for (int x = 0; x < STAGE_WIDTH; x++)
            {
                // ̎wWɃ^Cꍇ
                if (tiles_Type[x, y] != 0)
                {
                    // wW̉Ƀ^CȂꍇ
                    if (tiles_Type[x, y-1] == 0)
                    {
                        // wW̃^C̎ށiFj̏̍Wɂ炷
                        tiles_Type[x, y - 1] = tiles_Type[x, y];
                        // wW̃^CTransform̍Wɂ炷
                        tiles_Transform[x, y - 1] = tiles_Transform[x, y];

                        // wW̃^C͉ɂꂽ̂ŁAwW̃^C̎ނ0i^CȂjɂ
                        tiles_Type[x, y] = 0;
                        // wW̃^C͉ɂꂽ̂ŁAwWTransformnulli^CȂjɂ
                        tiles_Transform[x, y] = null;

                        // wW̃^C̃Q[IuWFNgɂP炷
                        tiles_Transform[x, y - 1].transform.position -= new Vector3(0, 1, 0);

                        // tileDownStatustruê܂܁AFor[vʂ
                        // P̃^Cɑ΂ĉɂ炷񐔂1Ƃ͌Ȃ̂ŁA
                        // 1xFor[vʂāAĂяoWhileēxFor[vs
                        // 邱ƂŁA^C̉ɂ܂SȂԂ܂ŌJԂƂł
                        tileDownStatus = true;
                        return;
                    }
                }
            }
        }

        // ^C̉ɂ܂SȂȂꍇɁAtileDownStatusfalseɂāAĂяoWhileʂ
        tileDownStatus = false;
    }
}
